Attribute VB_Name = "modDeclares"
Option Explicit

'API declares
Public Declare Function GetTickCount Lib "kernel32" () As Long
Public Declare Sub RtlMoveMemory Lib "kernel32" (Dest As Any, Src As Any, ByVal cb&)

Public Declare Function SetWindowLongA Lib "user32" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function CallWindowProcA Lib "user32" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long

'Public Declare Function CreateWindowExA Lib "user32" (ByVal dwExStyle As Long, ByVal lpClaName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
'Public Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long

Public Declare Function WritePrivateProfileStringA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpString As Any, ByVal lpFileName As String) As Long
Public Declare Function GetPrivateProfileStringA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Public Declare Function GetVolumeInformationA Lib "kernel32" (ByVal lpRootPathName As String, ByVal lpVolumeNameBuffer As Long, ByVal nVolumeNameSize As Long, lpVolumeSerialNumber As Long, ByVal lpMaximumComponentLength As Long, ByVal lpFileSystemFlags As Long, ByVal lpFileSystemNameBuffer As Long, ByVal nFileSystemNameSize As Long) As Long

Public Declare Function GetTimeZoneInformation Lib "kernel32" (lpTimeZoneInformation As TIME_ZONE_INFORMATION) As Long
Public Type SYSTEMTIME
 wYear As Integer
 wMonth As Integer
 wDayOfWeek As Integer
 wDay As Integer
 wHour As Integer
 wMinute As Integer
 wSecond As Integer
 wMilliseconds As Integer
End Type
Public Type TIME_ZONE_INFORMATION
 Bias As Long
 StandardName(32) As Integer
 StandardDate As SYSTEMTIME
 StandardBias As Long
 DaylightName(32) As Integer
 DaylightDate As SYSTEMTIME
 DaylightBias As Long
End Type

'Constants
Public Const MAX_X = 16384
Public Const MAX_Y = 16384

Public Const MAX_BOTS = 10 'Limit memory
Public Const MAX_USERS = 300 'Limit 255
Public Const MAX_ALIASES = 200000
Public Const MAX_RANKS = 200000
Public Const MAX_AMACHS = 32766 'answering machine messages made
Public Const MAX_PROFILES = 200000 '1000000
Public Const MAX_SCORES = 254 'saves 0 and 1 team scores for each arena
'Public Const MAX_SECURES = 254 'Limit memory
'Public Const MAX_QUEUED = 254 'Limit 255
'Public Const MAX_BACKLOG = 32766 '254 '30 'Limit memory. don't lower this or the bot will start responding very slowly!
Public Const MAX_TERMINALLINES = 100
Public Const MAX_SETTINGS = 83 'for monkeybot
Public Const MAX_SETTINGCATEGORIES = 30 'currently 30 for continuum 1.36

Global Const Vanilla = 1
Global Const Race = 2
Global Const wbelim = 3
Global Const wbrace = 4
Global Const javelim = 5
Global Const javrace = 6
Global Const teamelim = 7
Global Const GolfElim = 8

'SubSpace FTP; you can download/upload files with bot. needed for monkeybot
'At startup, a file with a null character file name is received, but not actually written to the hard drive. I couldn't find the cause of that.
Public Enum Simple_FTP_TYPES
 None = 0
 SimpleSettings = 15
 Settings = 16
End Enum
Public Type FTP_SessionTYPES
 FTP_Name As String
 FTP_Data As String
 FTP_Type As Simple_FTP_TYPES
 FTP_FileLen As Long
 FTP_Recved As Long
End Type
Public FTPList(1 To MAX_BOTS) As FTP_SessionTYPES

'SSL structures. this stuff i don't know what it does (something about resending secure messages as not secure). but works without it
'Public Type SecureMessageTYPES
' Message As String
' ResendCount As Integer
' BotFrom As Byte
' InitialTicks As Long
'End Type
'Public Secures(1 To MAX_SECURES) As SecureMessageTYPES

'Structs
Public Type UserTYPES
 Name As String 'not lowercased
 Squad As String
 Ship As Byte
 Freq As Integer
 Wins As Integer 'for elim, reset when starting by *scorereset. for freeelim just reset
 Losses As Integer 'for elim, reset when starting by *scorereset. for freeelim just reset
 Points As Long 'for bot .type 3
 GamePoints As Byte 'for golf elim
 Playing As Boolean 'used for bot types 1,2,3,7 (elim,zombie,swz shipchecker,freeelim)
 BLevel As Byte
 ZLevel As Byte 'can be set to zone op also. before adding ops as zone ops with -op, make sure the ops are logged in as regular players or not in sysop.txt, smod.txt or moderate.txt
 X As Integer
 Y As Integer
 Xs As Integer 'needed for the antiwarp bot (last coords of player so bot would warp him/her there if in anti-warp box)
 Ys As Integer
 D As Byte
'' Fire As Integer
' ProfileLoginCode As String 'failed to be user friendly
End Type

Public Enum GAME_STATUS
 CHECK = 0
 VOTE_GAME = 1
 VOTE_DEATHS = 2
 WAIT = 3
 started = 4
 PAUSE = 5
 WAIT_AFTER_RESULTS = 6
End Enum

Public Type BotTYPES
 Enabled As Boolean 'for game type of bots

 Status As GAME_STATUS
 MaxDeaths As Byte 'in game, players have to not die this many to win. in other game, players just have to kill this much
 GameCounter As Byte 'not saved

 ErrorChannel As String
 GameSound As Byte '0-off,1-on so we wouldn't have to use '* Abs(.GameSound)' everywhere

 AutoSpec As Integer 'spec players on number of deaths
 PrizeBot As Boolean
 PrizeNumber As Integer '-28 to 28
 PrizeCounter As Integer
 PrizeTime As Integer
 KillPrize As Integer 'for every kill give this prize
 LockShips As Byte
 BallNotify As Byte
 BallPlayer As Integer
 BallTeam As Integer
 Suicide As Boolean
 EvenTeams As Integer
 EvenCounter As Byte
 ShipResetBot As Integer '0-disabled, 1-manual, >1-automatic periodic ship reseting for all players.
 ShipResetCounter As Integer
 AntiBot As Boolean
 AntiBoxX1 As Integer
 AntiBoxY1 As Integer
 AntiBoxX2 As Integer
 AntiBoxY2 As Integer
 AntiPixels As Integer

 LogScores As Boolean 'log scores for each arena for freq 0 and 1

 NewsFile As String

 BountyRabbitUserIndex As Integer 'which player is the rabbit by .UserID

 X As Integer
 Y As Integer
 Ship As Byte
 FlyResponse As Integer 'adjust how often flybot responds. even if the delay is 0, it will respond only if something is received from server (players doing something like firing/flying)
 LastFlyResponse As Long 'not saved. long because GetTickCount returns long
 Freq As Integer
 AttachedTo As Integer '-1 for no one (must be an integer, Bytes can only be 0 to 255)
 CoordM(98) As String 'have ability to put locations in memory, retrieve, delete
 XSpeed As Integer 'don't need to put in UserTYPES; this kind of packet isn't sent thru port
 YSpeed As Integer
 SpeedMax As Integer
 MyDir As Integer 'player to turn with. -1 for no one
 Fire As Integer
 Fly As Boolean
 Dir As Byte
 FlyRadius As Integer
 FlyRadiusM(98) As String 'have ability to put radiuses in memory, retrieve, delete
 FlyCenterX As Integer 'around what coordinates will bot fly the flyradius
 FlyCenterY As Integer
 FlyCenterM(98) As String
 Follow As Integer 'player to follow. -1 for no one
'' Catchee As integer 'player who wants to follow the bot. -1 for no one

' NumHits As Integer 'for bot to be able to die (certain number of hits in certain time length)
' TimeHitsStarted As Long

 UserID As Integer 'UserID of a bot among players, not saved
 Name As String 'not lowercased
 Password As String
 Type As Byte
 ElimType As Byte
 Arena As String 'not saved, but used to temporarily record current arena so we wouldn't have to call GetSpawnConnected everytime we have to find out which arena we are in
 LocalArena As String 'saved
 RemoteArena As String 'saved
 HasSysop As Boolean 'for bounty, doormodes. if have the sysop password in .ini
' GameBanBots As Boolean 'this one didn't work out so well; it would require more code that would make the lynxbot slower/laggier
 Welcome As String 'welcome message: custom/default
 LoginSound As String
 MacID As String 'now bots can have custom macid
 TimeZoneBiasAdjust As Integer 'will log in with your comp's time plus this value

 DownloadingSettings As Boolean
 MonkeyRate As Integer
 MonkeyCounter As Integer
 Monkey As Boolean

 Spawning As Boolean
 SpawnConnected As Boolean 'logged in. now can start Periodic_Timer to check on games and prizing
 AutoConnect As Boolean 'this starts after trying to spawn until connected or when lost connection
 GotSync As Boolean
 SyncLocal As Long
 SyncDiff As Long
 TotalSecuresSent As Long 'subspace requires us to send a number that counts how many packets (accept files, logons, acks, pings we sent to subspace
 TotalSent As Long
 TotalReceived As Long
 KeepAliveTime As Integer 'used for not lagging out if nothing is happening in zone
 KeepAliveCounter As Integer

' PingTime As Long 'don't need; bot will lag much less without -lag info
' AvgPing As Long
' TotalPings As Long

' UseQueue As Boolean
' QueuedMessages(1 To MAX_QUEUED) As String

' LastPacketID As Integer 'for backlog

 Sock As sockaddrTYPES 'what currently ip/port a bot is loggen on with (saved in .ini as Spawn: "Local"/"Remote"/"Closed". when LYNXbot launches again, it will respawn the last spawned bots)
 SockID As Long 'when receiving winsock stack, receive it to the right bot
 LocalIP As String 'although we have ip/port in sockaddr, we need separate one of these because we need them for local and remote connections. local: spawn on our own server. remote: spawn on somebody else's zone
 LocalPort As Integer
 LocalSysopPassword As String
 RemoteIP As String
 RemotePort As Integer
 RemoteSysopPassword As String

'stuff that's remarked with ''' is replacement of ssme.dll dependency with Cypher() function
'didn't work
 SSEncrTable As SSEncrTableTYPES 'needed for subspace
 SSEncrKey As Long

 Users(MAX_USERS) As UserTYPES 'array of 255 logged in players for the 10 dimensioned bots (bots' indexes are also in the Users() array (by Bots(#).Users(Bots(#).UserID)))
 TotalPlaying As Integer 'will be counted down as players die/logout/go in spec while a game is played (from bot types that play games)
 TotalUsers As Integer 'used to show in title bar
 LastUser As Integer '0,1,2,3,4,6,11,12,13,20,30. .lastuser would be the 30
End Type
Public Bots(1 To MAX_BOTS) As BotTYPES
Public LastBot As Byte 'so rest of program would not scan beyond not connected bots
Public LastConnectingBot As Byte 'in WindowProc function continue scanning thru not-connected, but possibly connecting ones until BotIndex reaches LastConnectingBot so we wouldn't waste time for rest

'Player aliasing. used to find other aliases player has been using; must enable the aliasfinder to collect aliases
Public Type AliasTYPES
 Name As String 'lowercased
 IP As String
 MacID As String
End Type
Public Alias(1 To MAX_ALIASES) As AliasTYPES
Public LastAlias As Long
Public StartOfNewAlias As Long 'will be set to LastAlias once a new alias is loggen on, then it won't change so it would save only the new aliases (use much less hard drive)

'Player rankings; the ones saved to Rank.txt. for FreeElim bot the kills/deaths don't come from subspace's records. they are reset when game starts but it doesn't reset subspace ones.
Public Type RanksTYPES
 Name As String
 Wins As Long
 Losses As Long
 GamesWon As Long
 GamesPlayed As Long
End Type
Public Ranks(1 To MAX_RANKS) As RanksTYPES
Public LastRank As Long

'Conquer! statistics
Public Type ConquerTYPES
 Freq As Integer
 CurrentPlayers(1 To MAX_USERS) As Integer
 TotalCurrent As Integer
 InitialOwner As Integer
End Type
Public Conquer(1 To MAX_BOTS, 1 To MAX_USERS) As ConquerTYPES
Public TotalFreqs(1 To MAX_BOTS) As Integer

'Score statistics
Public Type FreqScoreTYPES
 Wins As Long
 Losses As Long
 FlagVictories As Long
End Type
Public Type ScoreTYPES
 Arena As String
 Freq(1) As FreqScoreTYPES
End Type
Public Scores(1 To MAX_SCORES) As ScoreTYPES
Public LastScores As Byte

Public Type TerminalTYPES
 Msg As String
 MsgType As Byte 'color
End Type
Public Terminal(MAX_BOTS, 1 To MAX_TERMINALLINES) As TerminalTYPES
Public TerminalLines(MAX_BOTS) As Byte

'Packet backlog. these are needed
'Public Type BacklogTYPES
' Data As String
' PacketID As Integer
' Closed As Boolean
'End Type
'Public Backlog(1 To MAX_BOTS, 1 To MAX_BACKLOG) As BacklogTYPES
'Public LastBacklog As Integer
Public ACKs(1 To MAX_BOTS, -32768 To 32767) As Boolean 'switches; whether to send/not to send backlog received from subspace

'Settings
Public Type SettingKeyTYPES
 KeyName As String
 Current As Integer
 Original As Integer
 Minimum As Integer
 Maximum As Integer
 Changed As Boolean
End Type
Public Type SettingCategoryTYPES
 CategoryName As String
 CategorySettings(MAX_SETTINGS) As SettingKeyTYPES
 LastKey As Byte
End Type
Public Setting(1 To MAX_BOTS, 1 To MAX_SETTINGCATEGORIES) As SettingCategoryTYPES
Public LastCategory(1 To MAX_BOTS) As Byte

Public Type AMachTYPES 'Answering Machine
 Msg As String
 From As String
 To As String
 Subject As String
 ReadSent As Boolean 'read message that was sent (to me or from me)
 Sent As Boolean
 Anonymous As Boolean '.From will always have the sender's name so you'd know it's not yours when using '-amach o' command
 Date As String 'date with time
End Type
Public AMach(1 To MAX_AMACHS) As AMachTYPES
Public LastAMachMsg As Integer

Public Type ProfileTYPES 'Profiles (AliasFinder dependent)
 Name As String
' Code As String 'so 1 player could have more than 1. when created a profile with code, the next time user logs in, he/she will have to -profile login (code) to enable editing
 MacID As String 'replaced with this
 Hidden As Boolean
 Profile As String
End Type
Public Profile(1 To MAX_PROFILES) As ProfileTYPES
Public LastProfile As Long

'Quick lists. these are just used in program for reference. they are set in DefaultVariables when program starts
Public ShipName(1 To 8) As String
Public BotName(7) As String
Public BOpName(3) As String
Public ZOpName(3) As String
Public PrizeName(-28 To 28) As String

'Other settings that are saved to .ini
Public LogTerminal As Boolean
Public AliasFinder As Boolean
Public BotInFocus As Byte 'in focus from Terminal window
Public GameBans As String
Public TextEditor As String 'If the default Notepad is not found, when choosing Edit Settings menu, file dialog will show so you could choose alternative editor.

'Public Map(1023, 1023) As String * 1, MapDefaultDir As String, MapDefaultName As String, MapFullName As String

Function GetProfile(sectn As String, kee As String, dVal As String, dValIfBlank As Boolean) As String
Dim S255 As String * 255, b As Byte
b = GetPrivateProfileStringA(sectn, kee, dVal, ByVal S255, 255, GetLongFileName(App.Path, App.Title & ".ini"))
If b > 0 Then GetProfile = Left(S255, b) Else If dValIfBlank Then GetProfile = dVal
End Function

'For some reason if some strings are blank and are tried to be saved, their keys aren't even made, but for other blank string variables, the keys are made. So I used FillZero() function and it worked
Sub SetProfile(sectn As String, kee As String, valu As String)
WritePrivateProfileStringA sectn, kee, FillZero(valu, 255), GetLongFileName(App.Path, App.Title & ".ini")
End Sub

'Login IDs
Function MachineID() As Long
Dim L As Long
GetVolumeInformationA "C:\", 0&, 0&, L, 0&, 0&, 0&, 0&
MachineID = L ' - 1 remarked by me
End Function

Function TimeZoneBias() As Integer
Dim v As TIME_ZONE_INFORMATION
GetTimeZoneInformation v
'TimeZoneBias = CInt(TimeZone.Bias - 30) 'remarked by me
TimeZoneBias = v.Bias
End Function

'Debug output
Function PHex(RawHex As String) As String
Dim S As String, I As Integer, H As String
For I = 1 To Len(RawHex)
 H = Hex(Asc(Mid(RawHex, I, 1)))
 If Len(H) = 1 Then H = "0" + H
 S = S + H + " "
Next
PHex = S
End Function

'Formatting
Function FillZero(RawText As String, DesiredLength) As String
If DesiredLength = Len(RawText) Then
 FillZero = RawText
ElseIf DesiredLength > Len(RawText) Then
 FillZero = RawText + String(DesiredLength - Len(RawText), Chr(0))
Else
 FillZero = Left(RawText, DesiredLength)
End If
End Function

Function TrimZero(RawText As String) As String
Dim I As Integer
I = InStr(RawText, Chr(0))
If I > 0 Then
 TrimZero = Left(RawText, I - 1)
Else
 TrimZero = RawText
End If
End Function

Function TrimSpace(mStr As String) As String
Dim I As Integer, S As String
S = Trim(mStr)
I = InStr(2, S, " ")
Do While I > 0
 S = Left(S, I - 1) + Mid(S, I + 1)
 I = InStr(I, S, " ")
Loop
TrimSpace = S
End Function

'Conversion / extraction
Function GetInteger(RawText As String) As Integer
Dim I As Integer
RtlMoveMemory I, ByVal RawText, 2
GetInteger = I
End Function

Function GetLong(RawText As String) As Long
Dim L As Long
RtlMoveMemory L, ByVal RawText, 4
GetLong = L
End Function

Function GetStringL(L As Long) As String
Dim S As String * 4
RtlMoveMemory ByVal S, L, 4
GetStringL = S
End Function

Function GetStringI(I As Integer) As String
Dim S As String * 2
RtlMoveMemory ByVal S, I, 2
GetStringI = S
End Function

'File I/O
Sub PutBytes(Filename As String, Contents As String)
Dim freefilenumber As Integer
On Error GoTo ErrHandler
freefilenumber = FreeFile
Open Filename For Output As freefilenumber
 Print #freefilenumber, Contents
ErrHandler:
Close freefilenumber
End Sub

Sub AppendBytes(Filename As String, Contents As String)
Dim freefilenumber As Integer
On Error GoTo ErrHandler
freefilenumber = FreeFile
Open Filename For Append As freefilenumber
 Print #freefilenumber, Contents
ErrHandler:
Close freefilenumber
End Sub

Sub UpdatePriority(Priority)
If GetPriorityClass(GetCurrentProcess) <> Priority Then SetPriorityClass GetCurrentProcess, Priority
End Sub
